{%- from "designate/map.jinja" import worker with context %}
{%- if worker.get('enabled', False) %}

designate_worker_packages:
  pkg.installed:
  - names: {{ worker.pkgs }}

designate_worker_services:
  service.running:
    - enable: true
    - names: {{ worker.services }}
    - watch:
      - file: /etc/designate/designate.conf

{% for service_name in worker.services %}
{{ service_name }}_default:
  file.managed:
    - name: /etc/default/{{ service_name }}
    - source: salt://designate/files/default
    - template: jinja
    - require:
      - pkg: designate_worker_packages
    - defaults:
        service_name: {{ service_name }}
        values: {{ worker }}
    - watch_in:
      - service: designate_worker_services
{% endfor %}

{% if worker.logging.log_appender %}

{%- if worker.logging.log_handlers.get('fluentd', {}).get('enabled', False) %}
designate_fluentd_worker_logger_package:
  pkg.installed:
    - name: python-fluent-logger
{%- endif %}

{% for service_name in worker.services %}
{{ service_name }}_worker_logging_conf:
  file.managed:
    - name: /etc/designate/logging/logging-{{ service_name }}.conf
    - source: salt://oslo_templates/files/logging/_logging.conf
    - template: jinja
    - makedirs: True
    - user: designate
    - group: designate
    - defaults:
        service_name: {{ service_name }}
        _data: {{ worker.logging }}
    - require:
      - pkg: designate_worker_packages
{%- if worker.logging.log_handlers.get('fluentd', {}).get('enabled', False) %}
      - pkg: designate_fluentd_worker_logger_package
{%- endif %}
    - watch_in:
      - service: designate_worker_services
{% endfor %}
{% endif %}

{%- endif %}
